﻿  
CREATE PROCEDURE [dbo].[SStagin_InsertImportCompanyProfile]
@TemplateName NVARCHAR(200)='',
@ImportFileName NVARCHAR(200)='',
@jsonTrend NVARCHAR(MAX),
@UserCreatedById UNIQUEIDENTIFIER	
AS
/*================================================================================    
Procedure Name: SStagin_InsertImportTrend    
Change History    
Date  Developer  Reason    
__________ ____________ ______________________________________________________    
05/04/2019 Praveen   Initial Version    
================================================================================*/ 
DECLARE @ImportId UNIQUEIDENTIFIER =NEWID()
declare @ErrorMsg NVARCHAR(2048),@CreatedOn Datetime
BEGIN
	SET @CreatedOn = GETDATE()
	BEGIN TRY   
	INSERT INTO ImportData
	(Id               , 
TemplateName		  ,
ImportFileName		  ,
--ImportStatusId		  ,
--ImportException		  ,
ImportedOn			  ,
UserImportedById)
VALUES(@ImportId, @TemplateName, @ImportFileName,@CreatedOn, @UserCreatedById)
---------------------------------------------------
INSERT INTO StagingCompanyProfile (Id                  ,
ImportId									 ,
CompanyName									 ,
Nature										 ,
CompanySubsdiaryName						 ,
CompanySubsdiaryLocation					 ,
CompanyParentName							 ,
HQ											 ,
PhoneNumber1								 ,
PhoneNumber2								 ,
PhoneNumber3								 ,
Mail1										 ,
Mail2										 ,
Mail3										 ,
Website										 ,
FoundedYear									 ,
CompanyStage								 ,
Geographies									 ,
NumberofEmployees							 ,
AsonDate									 ,
KeyEmployeeName								 ,
KeyEmplyeeDesignation						 ,
KeyEmployeeEmail							 ,
KeyEmployeeComments							 ,
BoardofDirectorName							 ,
BoardofDirectorEmail 						 ,
BoardofDirectorOtherCompany					 ,
BoardofDirectorOtherCompanyDesignation		 ,
CompanyRank_Rank							 ,
CompanyRank_Rationale						 ,
Name										 ,
Entity										 ,
Holding										 ,
Level										 ,
Designation									 ,
Product_ServiceName							 ,
LaunchDate									 ,
ProductCategory								 ,
Segment										 ,
Revenue										 ,
Units										 ,
Currency									 ,
TargetedGeogrpahy							 ,
Patents										 ,
Decription_Remarks							 ,
Status										 ,
Currency1									 ,
Unit										 ,
TableType									 ,
TotalRevenue								 ,
Revenue_2018								 ,
Revenue_2017								 ,
Revenue_2016								 ,
Revenue_2015								 ,
Revenue_2014								 ,
Profit										 ,
Profit_2018									 ,
Profit_2017									 ,
Profit_2016									 ,
Profit_2015									 ,
Profit_2014									 ,
ExpenseUnit									 ,
ExpenseCurency								 ,
OtherFinancialTableType						 ,
TotalExpense								 ,
Expence_2018								 ,
Expence_2017								 ,
Expence_2016								 ,
Expence_2015								 ,
Expence_2014								 ,
Currency11									 ,
Period										 ,
Base_Date									 ,
Date1										 ,
Price										 ,
Volume										 ,
Date2										 ,
Organic_Inorganic							 ,
Strategy									 ,
Category									 ,
ImportanceH_M_L								 ,
ClientName									 ,
ClientIndustry								 ,
Remarks										 ,
ImportDate									 ,
News										 ,
NewsCategory								 ,
ImportanceH_M_L1							 ,
Impact_positive_Negative					 ,
OtherParticipants							 ,
Remarks1									 ,
ESMPresence									 ,
SectorPresence								 ,
KeyCompetitor								 ,
Strenght									 ,
Weakness									 ,
Opportunity									 ,
Threats										 ,
Trends										 ,
Department									 ,
Importance									 ,
Impact										 ,
AddVendorInfoTable							 ,
AddLitigationsAndOtherLegalInfo				 ,
AddPatentRelatedInfo						 ,
AddAnyotherinfo								 ,
AddTable									 ,
AnalystViewText,
ErrorNotes,
ProjectName)
Select 
NewId()                  ,
@ImportId									 ,
CompanyName									 ,
Nature										 ,
CompanySubsdiaryName						 ,
CompanySubsdiaryLocation					 ,
CompanyParentName							 ,
HQ											 ,
PhoneNumber1								 ,
PhoneNumber2								 ,
PhoneNumber3								 ,
Mail1										 ,
Mail2										 ,
Mail3										 ,
Website										 ,
FoundedYear									 ,
CompanyStage								 ,
Geographies									 ,
NumberofEmployees							 ,
AsonDate									 ,
KeyEmployeeName								 ,
KeyEmplyeeDesignation						 ,
KeyEmployeeEmail							 ,
KeyEmployeeComments							 ,
BoardofDirectorName							 ,
BoardofDirectorEmail 						 ,
BoardofDirectorOtherCompany					 ,
BoardofDirectorOtherCompanyDesignation		 ,
CompanyRank_Rank							 ,
CompanyRank_Rationale						 ,
Name										 ,
Entity										 ,
Holding										 ,
Level										 ,
Designation									 ,
Product_ServiceName							 ,
LaunchDate									 ,
ProductCategory								 ,
Segment										 ,
Revenue										 ,
Units										 ,
Currency									 ,
TargetedGeogrpahy							 ,
Patents										 ,
Decription_Remarks							 ,
Status										 ,
Currency1									 ,
Unit										 ,
TableType									 ,
TotalRevenue								 ,
Revenue_2018								 ,
Revenue_2017								 ,
Revenue_2016								 ,
Revenue_2015								 ,
Revenue_2014								 ,
Profit										 ,
Profit_2018									 ,
Profit_2017									 ,
Profit_2016									 ,
Profit_2015									 ,
Profit_2014									 ,
ExpenseUnit									 ,
ExpenseCurency								 ,
OtherFinancialTableType						 ,
TotalExpense								 ,
Expence_2018								 ,
Expence_2017								 ,
Expence_2016								 ,
Expence_2015								 ,
Expence_2014								 ,
Currency11									 ,
Period										 ,
Base_Date									 ,
Date1										 ,
Price										 ,
Volume										 ,
Date2										 ,
Organic_Inorganic							 ,
Strategy									 ,
Category									 ,
ImportanceH_M_L								 ,
ClientName									 ,
ClientIndustry								 ,
Remarks										 ,
ImportDate									 ,
News										 ,
NewsCategory								 ,
ImportanceH_M_L1							 ,
Impact_positive_Negative					 ,
OtherParticipants							 ,
Remarks1									 ,
ESMPresence									 ,
SectorPresence								 ,
KeyCompetitor								 ,
Strenght									 ,
Weakness									 ,
Opportunity									 ,
Threats										 ,
Trends										 ,
Department									 ,
Importance									 ,
Impact										 ,
AddVendorInfoTable							 ,
AddLitigationsAndOtherLegalInfo				 ,
AddPatentRelatedInfo						 ,
AddAnyotherinfo								 ,
AddTable									 ,
AnalystViewText,
ErrorNotes,
ProjectName
 FROM OPENJSON(@jsonTrend)
    WITH ( 
[CompanyName] [nvarchar](255) ,
[Nature] [nvarchar](255) ,
[CompanySubsdiaryName] [nvarchar](255) ,
[CompanySubsdiaryLocation] [nvarchar](255) ,
[CompanyParentName] [nvarchar](255) ,
[HQ] [nvarchar](255) ,
[PhoneNumber1] [nvarchar](255) ,
[PhoneNumber2] [nvarchar](255) ,
[PhoneNumber3] [nvarchar](255) ,
[Mail1] [nvarchar](255) ,
[Mail2] [nvarchar](255) ,
[Mail3] [nvarchar](255) ,
[Website] [nvarchar](255) ,
[FoundedYear] [nvarchar](255) ,
[CompanyStage] [nvarchar](255) ,
[Geographies] [nvarchar](255) ,
[NumberofEmployees] [nvarchar](255) ,
[AsonDate] [nvarchar](255) ,
[KeyEmployeeName] [nvarchar](255) ,
[KeyEmplyeeDesignation] [nvarchar](255) ,
[KeyEmployeeEmail] [nvarchar](255) ,
[KeyEmployeeComments] [nvarchar](255) ,
[BoardofDirectorName] [nvarchar](255) ,
[BoardofDirectorEmail] [nvarchar](255) ,
[BoardofDirectorOtherCompany] [nvarchar](255) ,
[BoardofDirectorOtherCompanyDesignation] [nvarchar](255) ,
[CompanyRank_Rank] [nvarchar](255) ,
[CompanyRank_Rationale] [nvarchar](255) ,
[Name] [nvarchar](255) ,
[Entity] [nvarchar](255) ,
[Holding] [nvarchar](255) ,
[Level] [nvarchar](255) ,
[Designation] [nvarchar](255) ,
[Product_ServiceName] [nvarchar](255) ,
[LaunchDate] [nvarchar](255) ,
[ProductCategory] [nvarchar](255) ,
[Segment] [nvarchar](255) ,
[Revenue] [nvarchar](255) ,
[Units] [nvarchar](255) ,
[Currency] [nvarchar](255) ,
[TargetedGeogrpahy] [nvarchar](255) ,
[Patents] [nvarchar](255) ,
[Decription_Remarks] [nvarchar](255) ,
[Status] [nvarchar](255) ,
[Currency1] [nvarchar](255) ,
[Unit] [nvarchar](255) ,
[TableType] [nvarchar](255) ,
[TotalRevenue] [nvarchar](255) ,
[Revenue_2018] [nvarchar](255) ,
[Revenue_2017] [nvarchar](255) ,
[Revenue_2016] [nvarchar](255) ,
[Revenue_2015] [nvarchar](255) ,
[Revenue_2014] [nvarchar](255) ,
[Profit] [nvarchar](255) ,
[Profit_2018] [nvarchar](255) ,
[Profit_2017] [nvarchar](255) ,
[Profit_2016] [nvarchar](255) ,
[Profit_2015] [nvarchar](255) ,
[Profit_2014] [nvarchar](255) ,
[ExpenseUnit] [nvarchar](255) ,
[ExpenseCurency] [nvarchar](255) ,
[OtherFinancialTableType] [nvarchar](255) ,
[TotalExpense] [nvarchar](255) ,
[Expence_2018] [nvarchar](255) ,
[Expence_2017] [nvarchar](255) ,
[Expence_2016] [nvarchar](255) ,
[Expence_2015] [nvarchar](255) ,
[Expence_2014] [nvarchar](255) ,
[Currency11] [nvarchar](255) ,
[Period] [nvarchar](255) ,
[Base_Date] [nvarchar](255) ,
[Date1] [nvarchar](255) ,
[Price] [nvarchar](255) ,
[Volume] [nvarchar](255) ,
[Date2] [nvarchar](255) ,
[Organic_Inorganic] [nvarchar](255) ,
[Strategy] [nvarchar](255) ,
[Category] [nvarchar](255) ,
[ImportanceH_M_L] [nvarchar](255) ,
[ClientName] [nvarchar](255) ,
[ClientIndustry] [nvarchar](255) ,
[Remarks] [nvarchar](255) ,
[ImportDate] [nvarchar](255) ,
[News] [nvarchar](255) ,
[NewsCategory] [nvarchar](255) ,
[ImportanceH_M_L1] [nvarchar](255) ,
[Impact_positive_Negative] [nvarchar](255) ,
[OtherParticipants] [nvarchar](255) ,
[Remarks1] [nvarchar](255) ,
[ESMPresence] [nvarchar](255) ,
[SectorPresence] [nvarchar](255) ,
[KeyCompetitor] [nvarchar](255) ,
[Strenght] [nvarchar](255) ,
[Weakness] [nvarchar](255) ,
[Opportunity] [nvarchar](255) ,
[Threats] [nvarchar](255) ,
[Trends] [nvarchar](255) ,
[Department] [nvarchar](255) ,
[Importance] [nvarchar](255) ,
[Impact] [nvarchar](255) ,
[AddVendorInfoTable] [nvarchar](255) ,
[AddLitigationsAndOtherLegalInfo] [nvarchar](255) ,
[AddPatentRelatedInfo] [nvarchar](255) ,
[AddAnyotherinfo] [nvarchar](255),
[AddTable] [nvarchar](255),
[AnalystViewText] [nvarchar](255),
[ErrorNotes] [nvarchar](255),
[ProjectName] [nvarchar] (255)
 ) AS jsonTrends
 

 SELECT StoredProcedureName ='SStagin_InsertImportCompanyProfile',Message =@ErrorMsg,Success = 1;   
END TRY    
BEGIN CATCH    
    -- Execute the error retrieval routine.    
 DECLARE @ErrorNumber int;    
 DECLARE @ErrorSeverity int;    
 DECLARE @ErrorProcedure varchar;    
 DECLARE @ErrorLine int;    
 DECLARE @ErrorMessage varchar;    
    
  SELECT @ErrorNumber = ERROR_NUMBER(),    
        @ErrorSeverity = ERROR_SEVERITY(),    
        @ErrorProcedure = ERROR_PROCEDURE(),    
        @ErrorLine = ERROR_LINE(),    
        @ErrorMessage = ERROR_MESSAGE()    
    
 insert into dbo.Errorlog(ErrorNumber,    
       ErrorSeverity,    
       ErrorProcedure,    
       ErrorLine,    
       ErrorMessage,    
       ErrorDate)    
        values(@ErrorNumber,@ErrorSeverity,@ErrorProcedure,@ErrorLine,@ErrorMessage,@CreatedOn);    
  
 set @ErrorMsg = 'Error while importing Company Profile, please contact Admin for more details.';    
--THROW 50000,@ErrorMsg,1;      
--return(1)  
SELECT Number = @ErrorNumber, Severity =@ErrorSeverity,StoredProcedureName =@ErrorProcedure,LineNumber= @ErrorLine  
    ,Message =@ErrorMsg,Success = 0;     
     
END CATCH     


END